<?php
/**
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    PrestaShop SA <contact@prestashop.com>
*  @copyright 2007-2015 PrestaShop SA
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

if (!defined('_PS_VERSION_')) {
    exit;
}

use PrestaShop\PrestaShop\Core\Addon\Theme\ThemeManagerBuilder;
use PrestaShop\PrestaShop\Core\Addon\Theme\ThemeExporter;


class Profesionalhosting extends Module
{
    protected $config_form = false;

    public function __construct()
    {
        $this->name = 'profesionalhosting';
        $this->tab = 'administration';
        $this->version = '1.7.2';
        $this->author = 'ProfesionalHosting';
        $this->need_instance = 0;

        /**
         * Set $this->bootstrap to true if your module is compliant with bootstrap (PrestaShop 1.6)
         */
        $this->bootstrap = true;

        parent::__construct();

        $this->displayName = $this->l('ProfesionalHosting');
        $this->description = $this->l('Modulo para la descarga de plantillas y modulos proporcionados por ProfesionalHosting');

        $this->confirmUninstall = $this->l('Seguro que quiere desinstalar el módulo');
        $this->ps_versions_compliancy = array('min' => '1.7', 'max' => _PS_VERSION_);
        

    }

    /**
     * Don't forget to create update methods if needed:
     * http://doc.prestashop.com/display/PS16/Enabling+the+Auto-Update
     */
    public function install()
    {
        return parent::install();
    }

    public function uninstall()
    {
        return parent::uninstall();
    }

    /**
     * Load the configuration form
     */
    public function getContent()
    {
        /**
         * If values have been submitted in the form, process.
         */
        if (((bool)Tools::isSubmit('submitProfesionalhostingModule')) == true) {
            $this->postProcess();
        }
        if(isset($_POST['submitActualizarModulo'])){
        	$rutasandbox = _PS_CACHE_DIR_.'sandbox';

			if (!file_exists($rutasandbox)) {
  				mkdir($rutasandbox, 0775);
			}

			$uniqid = uniqid();
		    $sandbox = _PS_CACHE_DIR_.'sandbox'.DIRECTORY_SEPARATOR.$uniqid.DIRECTORY_SEPARATOR;
		    mkdir($sandbox);
		    
		    $urlmodulo = $_POST['urlUpdate'];
			$nombrezip = str_replace('http://descargas.profesionalhosting.com/modulo-prestashop/', '', $urlmodulo);
			$nombrezip = str_replace('.zip', '', $nombrezip);
			if (!Tools::copy($urlmodulo, $sandbox.'updateprofesionalhosting.zip')) {
				$this->errors[] = $this->l('Error during the file download');
		    } else {
				Tools::ZipExtract($sandbox.'updateprofesionalhosting.zip', _PS_MODULE_DIR_);
				unlink($sandbox.'updateprofesionalhosting.zip');
				Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules').'&conf=8&anchor=profesionalhosting');
			}
        }

		$string = file_get_contents("http://descargas.profesionalhosting.com/modulo-prestashop/version-17.json");
		$json_ver = json_decode($string, true);
		
		
		$updateVersion = '';
		if($json_ver['versionActual'] > $this->version){
			$updateVersion = "<div class='panel'>
								<div class='moduleconfig-content'>
									<div class='row'>
										<div class='col-xs-12'>
												<h2>Actualización del modulo disponible</h2>
												<p>Actualiza el modulo para disfrutar de las mejoras del mismo.</p>
												<p class='text-center'>
													<form method='post' action=''>
														<input type='hidden' name='urlUpdate' value='".$json_ver['urlUpdate']."' />
														<button id='module_form_submit_btn' class='btn btn-default pull-right' name='submitActualizarModulo' value='1' type='submit'>
															<i class='process-icon-update'></i>
															Actualizar
														</button>
													</form>
												</p>
										</div>
									</div>
								</div>
							</div>";
		}
		
		$psversion_tmp = explode('.', _PS_VERSION_);
		$psversion = '';
		if(count($psversion_tmp) > 3){
			for($i=0;$i<3;$i++){
				$psversion .= $psversion_tmp[$i];
				if($i < 2){
					$psversion .= '.';
				}
			}
		}

		
		$string = file_get_contents("http://descargas.profesionalhosting.com/descargas-clientes/themes-prestashop-17/plantillas.json");	
		$json_a = json_decode($string, true);
		$plantillas = '';

		$plantillas_comp = array();

		foreach($json_a as $plantilla) {
			foreach($plantilla['psversion'] as $version){
				if ($psversion == $version) {
					$plantillas_comp[] = $plantilla;
					continue;
				}
			}
		}

		foreach($plantillas_comp as $plantilla) {
			$datainfo = 'Version plantilla: '.$plantilla['version'].'<br>Versiones prestashop compatibles: '.implode(', ', $plantilla['psversion']);
			$plantillas .= '<option value="'.$plantilla['url'].'" data-img="'.$plantilla['img'].'" data-demo="'.$plantilla['demo'].'" data-info="'.$datainfo.'">'.$plantilla['nombre'].'</option>';
		}
		
		// Parseamos el json con los modulos
		$string = file_get_contents("http://descargas.profesionalhosting.com/descargas-clientes/modules-prestashop-17/modulos.json");
		$json_b = json_decode($string, true);
		$modulos = '';
		foreach($json_b as $modulo) {
			$modulos .= '<option value="'.$modulo['url'].'">'.$modulo['nombre'].'</option>';
		}

        //$this->context->smarty->assign('module_dir', $this->_path);
        $this->context->smarty->assign(
        	array(			
				'module_dir'	=> $this->_path,
				'updateVersion'	=> $updateVersion,
				'plantillas'	=> $plantillas,
				'modulos'		=> $modulos
			)
		);

        $output = $this->context->smarty->fetch($this->local_path.'views/templates/admin/configure.tpl');
				
        return $output;
    }
           
    protected function postProcess()
    {

		if(Tools::getValue('PROFESIONALHOSTING_PLANTILLA') != ''){
			$urlplantilla = Tools::getValue('PROFESIONALHOSTING_PLANTILLA');
			if(_PS_VERSION_ >= '1.7'){
		        $this->theme_manager = (new ThemeManagerBuilder($this->context, Db::getInstance()))->build();
				//$this->theme_manager->install($urlplantilla);
				try {
		            $this->theme_manager->install($urlplantilla);
		        } catch (Exception $e) {
		            $this->errors[] = $e->getMessage();
		        }

		        if (empty($this->errors)) {
		            Tools::redirectAdmin($this->context->link->getAdminLink('AdminThemes'));
		        }
			}
			//print_r($this->errors);		
		} elseif(Tools::getValue('PROFESIONALHOSTING_MODULO') != ''){
			$urlmodulo = Tools::getValue('PROFESIONALHOSTING_MODULO');
			if (!Tools::copy($urlmodulo, _PS_MODULE_DIR_.'profesionalhosting/modulo.zip')) {
				$this->errors[] = $this->l('Error during the file download');
		    } else {
				Tools::ZipExtract(_PS_MODULE_DIR_.'profesionalhosting/modulo.zip', _PS_MODULE_DIR_);
				unlink(_PS_MODULE_DIR_.'profesionalhosting/modulo.zip');
			}
		}
    }
}

